diff --git a/etc/lightdm/lightdm.conf.d/10-gamescope-session.conf b/etc/lightdm/lightdm.conf.d/10-gamescope-session.conf
new file mode 100644
index 0000000..d878360
--- /dev/null
+++ b/etc/lightdm/lightdm.conf.d/10-gamescope-session.conf
@@ -0,0 +1,4 @@
+[Seat:*]
+#autologin-user=
+#autologin-user-timeout=
+#autologin-session=
diff --git a/etc/sddm.conf.d/10-gamescope-session.conf b/etc/sddm.conf.d/10-gamescope-session.conf
new file mode 100644
index 0000000..8b8caf0
--- /dev/null
+++ b/etc/sddm.conf.d/10-gamescope-session.conf
@@ -0,0 +1,4 @@
+[Autologin]
+#Relogin=
+#Session=
+#User=
diff --git a/usr/bin/steamos-desktop-return b/usr/bin/steamos-desktop-return
new file mode 100755
index 0000000..c8f34cb
--- /dev/null
+++ b/usr/bin/steamos-desktop-return
@@ -0,0 +1,5 @@
+#!/usr/bin/env bash
+
+/usr/lib/os-session-select gamescope
+
+reboot
diff --git a/usr/bin/steamos-session-select b/usr/bin/steamos-session-select
index 19e4d47..e3c772d 100755
--- a/usr/bin/steamos-session-select
+++ b/usr/bin/steamos-session-select
@@ -1,12 +1,9 @@
 #!/usr/bin/bash
 
-# Hook for custom OS script
-GAMESCOPE_SESSION_SCRIPT="/usr/lib/os-session-select"
-if [ -f $GAMESCOPE_SESSION_SCRIPT ] ; then
-	# Call session script from the OS
-	${GAMESCOPE_SESSION_SCRIPT} $@
-else
-	# Simply call shutdown on the client
-	steam -shutdown
-fi
+ /usr/lib/os-session-select $@
 
+# Simply call shutdown on the client
+steam -shutdown
+# make sure all wine processes are DEAD dead.
+kill -9 $(ps -ef | grep -E -i '(wine|processid|\.exe)' | awk '{print $2}')
+systemctl --user stop gamescope-session-plus@steam.service
diff --git a/usr/lib/os-session-select b/usr/lib/os-session-select
new file mode 100755
index 0000000..e31cfa1
--- /dev/null
+++ b/usr/lib/os-session-select
@@ -0,0 +1,200 @@
+#!/usr/bin/env bash
+
+set -e
+
+die() { echo >&2 "!! $*"; exit 1; }
+
+SENTINEL_FILE="gamescope-session-type"
+
+# Determine the configuration directory
+if [[ "$USER" == "root" ]] ; then
+  config_dir="/home/$4/.config"
+else
+  config_dir="$HOME/.config"
+fi
+
+[[ -f "$config_dir/$SENTINEL_FILE" ]] && source "$config_dir/$SENTINEL_FILE"
+
+session="${1:-gamescope}"
+session_launcher=""
+create_sentinel=""
+
+if [[ "$2" == "--sentinel-created" ]]; then
+  SENTINEL_CREATED=1
+fi
+
+# Ensure necessary environment variables are set
+if [[ -z "$HOME" ]]; then
+  die "No \$HOME variable"
+fi
+
+update_config_sentinel() {
+  [[ $EUID == 0 ]] && die "Running $0 as root is not allowed"
+  mkdir -p "$config_dir"
+
+  if [[ ! -f "$config_dir/$SENTINEL_FILE" ]]; then
+    if [[ "$XDG_SESSION_TYPE" == "wayland" ]]; then
+      echo "SESSION_TYPE=wayland" > "$config_dir/$SENTINEL_FILE"
+    else
+      echo "SESSION_TYPE=x11" > "$config_dir/$SENTINEL_FILE"
+    fi
+    echo "DE=$XDG_CURRENT_DESKTOP" >> "$config_dir/$SENTINEL_FILE"
+  fi
+}
+
+configure_lightdm() {
+  sed -i "s/^.*autologin-user=.*/autologin-user=${USER}/" /etc/lightdm/lightdm.conf.d/10-gamescope-session.conf
+  sed -i "s/^.*autologin-user-timeout=.*/autologin-user-timeout=0/" /etc/lightdm/lightdm.conf.d/10-gamescope-session.conf
+  sed -i "s/^.*autologin-session=.*/autologin-session=$session_launcher/" /etc/lightdm/lightdm.conf.d/10-gamescope-session.conf
+}
+
+configure_gdm() {
+  if [[ "$SESSION_TYPE" == "wayland" ]]; then
+    if [[ -f /var/lib/AccountsService/users/"${USER}" ]]; then
+      sed -i "s|Session=.*|Session=$session_launcher|g" /var/lib/AccountsService/users/"$USER"
+    else
+      echo "[User]" > /var/lib/AccountsService/users/"$USER"
+      echo "Session=$session_launcher" >> /var/lib/AccountsService/users/"$USER"
+    fi
+  else
+    if [[ -f /var/lib/AccountsService/users/"$USER" ]]; then
+      sed -i "s|XSession=.*|XSession=$session_launcher|g" /var/lib/AccountsService/users/"$USER"
+    else
+      echo "[User]" > /var/lib/AccountsService/users/"$USER"
+      echo "XSession=$session_launcher" >> /var/lib/AccountsService/users/"$USER"
+    fi
+  fi
+  # enable auto-login
+  # We need timedlogin here
+  # autologin without timer fails after manual logout
+  if [[ -f /etc/gdm/custom.conf ]]; then
+    sed -i "s|TimedLoginEnable=.*|TimedLoginEnable=true|g" /etc/gdm/custom.conf
+    sed -i "s|TimedLoginDelay=.*|TimedLoginDelay=1|g" /etc/gdm/custom.conf
+    sed -i "s|TimedLogin=.*|TimedLogin=$USER|g" /etc/gdm/custom.conf
+    if [[ -z $(cat /etc/gdm/custom.conf | grep TimedLogin) ]]; then
+      sed -i "/\[daemon\]/a\TimedLoginEnable=true" /etc/gdm/custom.conf
+      sed -i "/TimedLoginEnable=true/a\TimedLoginDelay=1" /etc/gdm/custom.conf
+      sed -i "/TimedLoginDelay=1/a\TimedLogin=$USER" /etc/gdm/custom.conf
+    fi
+  fi
+}
+
+configure_sddm() {
+	if [[ -f "/etc/sddm.conf.d/kde_settings.conf"  ]] ; then
+	  sed -i "s/^.*Relogin=.*/Relogin=true/" /etc/sddm.conf.d/kde_settings.conf
+    if [[ -z $(cat /etc/sddm.conf.d/kde_settings.conf | grep Relogin) ]]; then
+      sed -i '/\[Autologin\]/a\Relogin=true' /etc/sddm.conf.d/kde_settings.conf
+    fi
+	  sed -i "s/^.*Session=.*/Session=$session_launcher/" /etc/sddm.conf.d/kde_settings.conf
+	  sed -i "s/^.*User=.*/User=${USER}/" /etc/sddm.conf.d/kde_settings.conf
+   else
+	  sed -i "s/^.*Relogin=.*/Relogin=true/" /etc/sddm.conf.d/10-gamescope-session.conf
+	if [[ -z $(cat /etc/sddm.conf.d/10-gamescope-session.conf | grep Relogin) ]]; then
+      sed -i '/\[Autologin\]/a\Relogin=true' /etc/sddm.conf.d/10-gamescope-session.conf
+    fi
+	  sed -i "s/^.*Session=.*/Session=$session_launcher/" /etc/sddm.conf.d/10-gamescope-session.conf
+	  sed -i "s/^.*User=.*/User=${USER}/" /etc/sddm.conf.d/10-gamescope-session.conf
+   fi
+}
+
+if [[ -z $SENTINEL_CREATED ]]; then
+  update_config_sentinel
+  export SENTINEL_CREATED=1
+fi
+
+if [[ $(grep -E '^X-KDE-PluginInfo-Version=' /usr/share/xsessions/plasmax11.desktop | cut -d'=' -f2) =~ 6.* ]] ; then
+  KDE6="true"
+fi
+
+case "$session" in
+  plasma-wayland-persistent)
+    if [[ "$DE" == "GNOME" ]]; then
+      session_launcher="gnome-wayland"
+    elif [[ "$DE" == "KDE" ]]; then
+      session_launcher="plasma"
+      [[ "$KDE6" != "true" ]] && session_launcher="plasmawayland"
+    fi
+    ;;
+  plasma-x11-persistent)
+    if [[ "$DE" == "GNOME" ]]; then
+      session_launcher="gnome-xorg"
+    elif [[ "$DE" == "KDE" ]]; then
+      session_launcher="plasmax11"
+      [[ "$KDE6" != "true" ]] && session_launcher="plasma"
+    elif [[ "$DE" == "MATE" ]]; then
+      session_launcher="mate"
+    fi
+    ;;
+  desktop|plasma)
+    if [[ "$SESSION_TYPE" == "wayland" ]]; then
+      if [[ "$DE" == "GNOME" ]]; then
+        session_launcher="gnome-wayland"
+      elif [[ "$DE" == "KDE" ]]; then
+        session_launcher="plasma"
+        [[ "$KDE6" != "true" ]] && session_launcher="plasmawayland"
+      fi
+    else
+      if [[ "$DE" == "GNOME" ]]; then
+        session_launcher="gnome-xorg"
+      elif [[ "$DE" == "KDE" ]]; then
+        session_launcher="plasmax11"
+        [[ "$KDE6" != "true" ]] && session_launcher="plasma"
+      elif [[ "$DE" == "MATE" ]]; then
+        session_launcher="mate"
+      fi
+    fi
+    create_sentinel=1
+    ;;
+  gamescope)
+    session_launcher="gamescope-session-steam"
+    create_sentinel=1
+    ;;
+  *)
+    die "Unrecognized session '$session'"
+    ;;
+esac
+
+echo "Updated user selected session to $session_launcher"
+
+if [[ ! -z $4 ]]; then
+  USER="$4"
+fi
+
+[[ -f "$config_dir/$SENTINEL_FILE" ]] && source "$config_dir/$SENTINEL_FILE"
+
+# Re-execute as root
+if [[ $EUID != 0 ]]; then
+exec pkexec "$(realpath $0)" "$session" --sentinel-created "$session_type" "$USER"
+exit 1
+fi
+
+# Find the home directory of the specified user
+USER_HOME=$(getent passwd "$USER" | cut -d: -f6)
+
+if ! grep -q "autologin" "/etc/group" ; then
+    groupadd -r autologin
+fi
+
+if ! id -nG "$USER" | grep -qw "autologin"; then
+    gpasswd -a "$USER" autologin
+fi
+
+if ! grep -q "nopasswdlogin" "/etc/group" ; then
+    groupadd -r nopasswdlogin
+fi
+
+if ! id -nG "$USER" | grep -qw "autologin"; then
+    gpasswd -a "$USER" nopasswdlogin
+fi
+
+if systemctl is-active --quiet lightdm; then
+    configure_lightdm
+fi
+
+if systemctl is-active --quiet sddm; then
+    configure_sddm
+fi
+
+if systemctl is-active --quiet gdm; then
+    configure_gdm
+fi
diff --git a/usr/share/applications/steam_return.desktop b/usr/share/applications/steam_return.desktop
new file mode 100644
index 0000000..b94a83f
--- /dev/null
+++ b/usr/share/applications/steam_return.desktop
@@ -0,0 +1,10 @@
+[Desktop Entry]
+Name=Return to Steam Gaming Mode
+Exec=steamos-desktop-return
+Icon=steamdeck-gaming-return
+Terminal=false
+Type=Application
+StartupNotify=false
+Comment=Quickly exit the session to switch to steam gaming mode
+Comment[ru]=Быстрый выход из сессии для перехода в игровой режим стим
+Categories=Game;
diff --git a/usr/share/icons/hicolor/scalable/actions/steamdeck-gaming-return.svg b/usr/share/icons/hicolor/scalable/actions/steamdeck-gaming-return.svg
new file mode 100644
index 0000000..5cff1ce
--- /dev/null
+++ b/usr/share/icons/hicolor/scalable/actions/steamdeck-gaming-return.svg
@@ -0,0 +1,7 @@
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg id="svg2" height="64" style="" viewBox="0 0 64 64" width="64" xmlns="http://www.w3.org/2000/svg" sodipodi:docname="deck_icon.svg" inkscape:version="1.2-dev (d2dd25d878, 2022-02-01, custom)" xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape" xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd" xmlns:svg="http://www.w3.org/2000/svg">
+    <path id="path42220" d="m 32 4 v 10 a 18 18 0 0 1 18 18 a 18 18 0 0 1 -18 18 v 10 a 28 28 0 0 0 28 -28 a 28 28 0 0 0 -28 -28 z" style="fill:#fff;fill-rule:evenodd"/>
+    <circle id="path43518" cx="32" cy="32" r="14" style="fill:#1a9fff;fill-rule:evenodd"/>
+    <path id="path52048" d="m 32 22 a 2 2 0 0 0 -1.4140625 .5859375 l -8 8 a 2.0002 2.0002 0 0 0 0 2.828125 l 8 8 a 2 2 0 0 0 2.828125 0 a 2 2 0 0 0 0 -2.828125 l -4.5859375 -4.5859375 h 11.171875 a 2 2 0 0 0 2 -2 a 2 2 0 0 0 -2 -2 h -11.171875 l 4.5859375 -4.5859375 a 2 2 0 0 0 0 -2.828125 a 2 2 0 0 0 -1.4140625 -.5859375 z" style="fill:#fff;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:0"/>
+    <g id="path89696" style=""/>
+</svg>
